#ifndef __MDNS_H
#define __MDNS_H

#include <pthread.h>

#include "mDNS/mDNSCore/mDNSClientAPI.h"  // defines the interface to the client layer above
#include "mDNS/mDNSPosix/mDNSPosix.h"     // defines the specific types needed on this platform

/**
const char mdns_kDefaultPIDFile[]       = "/var/run/iCast.pid";
const char mdns_kDefaultServiceType[]   = "_daap._tcp.";
const char mdns_kDefaultServiceDomain[] = "local.";
const char mdns_kDefaultServiceRoot[]   = "./files";
const char mdns_kDefaultServicePass[]   = "corvette";
const char mdns_kDefaultServiceName[]   = "iCast";
const int  mdns_kDefaultServicePort     = 5090;
**/

// static mDNS mdns_mDNSStorage;
// static mDNS_PlatformSupport mdns_PlatformStorage;

typedef struct mdns_PosixService mdns_PosixService;

struct mdns_PosixService {
  ServiceRecordSet coreServ;
  mdns_PosixService * next;
  int serviceID;
};

// static mdns_PosixService * mdns_gServiceList = NULL;
// static int mdns_gServiceID = 0;
// static mDNSu16     mdns_gServiceTextLen  = 0;
// static mDNSu8      mdns_gServiceText[sizeof(RDataBody)];

typedef struct
{
  pthread_t thread;
  
  mDNS mDNSStorage;
  mDNS_PlatformSupport PlatformStorage;
  mdns_PosixService * ServiceList;
  int ServiceID;

  char pid_file[32];
  char srvc_type[32];
  char srvc_host[32];
  char srvc_root[32];
  char srvc_pass[32];
  char srvc_name[32];
  long srvc_port;
  
  mDNSu16 text_leng;
  mDNSu8 srvc_text[sizeof(RDataBody)];
  
  int started;
  int hault;
} mdns_t;

mdns_t * mdns_Create ();
void mdns_Init (mdns_t *);
void mdns_Start (mdns_t *);
void mdns_Stop (mdns_t *);
void * mdns_Loop (void *);
void mdns_Destroy (mdns_t *);

#endif /* __MDNS_H */
