#include <stdio.h>          // For printf()
#include <stdlib.h>         // For exit() etc.
#include <string.h>         // For strlen() etc.
#include <unistd.h>         // For select()
#include <errno.h>          // For errno, EINTR
#include <arpa/inet.h>      // For inet_addr()
#include <netinet/in.h>     // For INADDR_NONE
#include <netdb.h>          // For gethostbyname()
#include <assert.h>         // For assert()
#include <sys/time.h>       // For struct timeval
#include <pthread.h>        // For pthreads, duh
#include <sys/uio.h>        // For read() etc
#include <sys/types.h>      // For socket stuff
#include <sys/socket.h>     // For socket stuff
#include <strings.h>        // For bzero()

#if COMPILER_LIKES_PRAGMA_MARK
#pragma mark ***** Command Line Arguments
#endif

static const char *gServiceRoot     = kDefaultServiceRoot;
static const char *gServicePass     = kDefaultServicePass;
static const char *gServiceName     = "iCast";
static const char *gServiceType     = kDefaultServiceType;
static const char *gServiceDomain   = kDefaultServiceDomain;
static const char *gPIDFile         = kDefaultPIDFile;
static int         gPortNumber      = kDefaultPortNumber;
static mDNSu16     gServiceTextLen  = 0;
static mDNSu8      gServiceText[sizeof(RDataBody)];

static void
ParseArguments (int argc, char **argv)
{
  int ch;
  
  // Set gProgramName to the last path component of argv[0]
  
  if (NULL == (gProgramName = strrchr(argv[0], '/')))
    gProgramName = argv[0];
  else
    gProgramName += 1;

  // Parse command line options using getopt
  
  do {
    if (-1 == (ch = getopt(argc, argv, "")))
      continue;
    
    switch (ch) {
      case 'p':
        gServicePass = optarg;
        break;
      case 'r':
        gServiceRoot = optarg;
        break;
      default:
        fprintf(stderr, "Unknown argument, %c\n", ch);
        exit(1);
        break;
    }
  } while (ch != -1);
  
  // gMDNSPlatformPosixVerboseLevel = 2;
}

#if COMPILER_LIKES_PRAGMA_MARK
#pragma mark ***** Main
#endif

int
main (int argc, char **argv)
{
  mStatus status;
  int result;
  
  (void)result;
  (void)gPIDFile;
  
  int datalen, datamax;
  
  StartListener();
//QueryiTunes();
//CreateServerInfo(&datalen, &datamax);
//CreateServerInfo();
  
  
  return 0;
}
